<?php

class Accelereyes_Reseller_Block_Admin_Edit_Form extends Mage_Adminhtml_Block_Widget_Form
{

    protected function _prepareForm()
    {

        $form = new Varien_Data_Form(array(
            'id'        => 'edit_form',
            'action'    => $this->getUrl('*/*/save', array('id' =>
                                                     $this->getRequest()->getParam('id'))),
            'method'    => 'post'
        ));

        $fieldset = $form->addFieldset('edit_reseller', array('legend' =>
                        Mage::helper('reseller')->__('Reseller Details')));

        $fieldset->addField('company', 'text', array(
            'name'   => 'company',
            'title'     => Mage::helper('reseller')->__('Company'),
            'label'     => Mage::helper('reseller')->__('Company'),
            'maxlength' => '100',
            'required'  => true,
        ));

        $fieldset->addField('reseller_code', 'text', array(
            'name'   => 'reseller_code',
            'title'     => Mage::helper('reseller')->__('Reseller Code'),
            'label'     => Mage::helper('reseller')->__('Reseller Code'),
            'maxlength' => '50',
            'required'  => true,
        ));

        $fieldset->addField('commission_rate', 'text', array(
            'name'   => 'commission_rate',
            'title'     => Mage::helper('reseller')->__('Commission Rate'),
            'label'     => Mage::helper('reseller')->__('Commission Rate'),
            'maxlength' => '25',
            'required'  => false,
        ));

        $fieldset->addField('payment_terms', 'text', array(
            'name'   => 'payment_terms',
            'title'     => Mage::helper('reseller')->__('Payment Terms (days)'),
            'label'     => Mage::helper('reseller')->__('Payment Terms (days)'),
            'maxlength' => '25',
            'required'  => false,
        ));

        $fieldset->addField('address', 'text', array(
            'name'   => 'address',
            'title'     => Mage::helper('reseller')->__('Company Address'),
            'label'     => Mage::helper('reseller')->__('Company Address'),
            'maxlength' => '100',
            'required'  => true,
        ));

        $form->setUseContainer(true);
        $form->setValues(Mage::registry('frozen_reseller')->getData());
        $this->setForm($form);

        return parent::_prepareForm();

    }
}
