<?php
/**
 * This is an endpoint that can be hit by installed Jacket application to log
 * various events or to store information about a users computer.  The endpoint
 * can be hit by HTTP GET or HTTP POST at this URL:
 *
 * http://www.accelereyes.com/usage
 *
 * POSTs are preferred due to more correct semantics and higher payload limits.
 * license_number is the preferred required column to provide as it ensures unique
 * identification of a license while host_id or customer_id can have multiple matches.
 *
 * The internal wiki page 'Product Event Logging' has more information and
 * instructions for hitting this URL from code.
 *
 * Tried to make this pretty flexible as was not certain of usage scenarios.
 */

// validation token that client most provide, prevents spurious logs and spider noise
$token = "4cd033c3a08b0818293411";

// fields that the client can set
$fields = array(
  'ip_address',
  'content'
);

$inputs = array();

// read inputs from GET or POST or display an error if invalid request
if (array_key_exists('token', $_GET) && $_GET['token'] == $token){
  foreach ($fields as $field){
    if (!empty($_GET[$field])) $inputs[$field] = trim(mysql_escape_string($_GET[$field]));
  }

} else if (array_key_exists('token', $_POST) && $_POST['token'] == $token){
  foreach ($fields as $field){
    if (!empty($_POST[$field])) $inputs[$field] = trim(mysql_escape_string($_POST[$field]));
  }

} else{
  echo("FAILURE: Invalid Request");
  exit();
}

if (empty($inputs['content'])){
  echo("FAILURE: Invalid Request");
  exit();
}

// use one of the required fields to fill in any missing information
$inputs['ip_address'] = $_SERVER['REMOTE_ADDR'];
if (strcmp("76.97.68.41", $inputs['ip_address']) == 0) {
  // ignore office
  echo("SUCCESS...but ignore office");
  exit();
}
// if (!empty($inputs['host_id'])){
//   $licenseSql = "SELECT * FROM license WHERE host_id = '" . $inputs['host_id'] . "'";
// }
// else if (!empty($inputs['customer_id'])){
//   $licenseSql = "SELECT * FROM license WHERE customer_id = '" . $inputs['customer_id'] . "'";
// }
// else if (!empty($inputs['license_number'])){
//   $licenseSql = "SELECT * FROM license WHERE license_number = '" . $inputs['license_number'] . "'";
// }
// else{
//   echo("FAILURE: Invalid Request");
//   exit();
// }

$link = Mage::getSingleton('core/resource')->getConnection('core_read');

// $licenseResult = $link->fetchAll($licenseSql);
// if (count($licenseResult) == 0){
//   error_log("Attempted license lookup for usage endpoint but found no matches:");
//   error_log($licenseSql);
//   echo("FAILURE: Invalid license");
//   exit();
// }
// else if (count($licenseResult) > 1){
//   error_log("Found multiple matches for license lookup, using first:");
//   error_log($licenseSql);
//   echo("FAILURE: too many licenses");
//   exit();
// }

// $license = $licenseResult[0];
// if (empty($inputs['host_id'])) $inputs['host_id'] = $license['host_id'];
// if (empty($inputs['customer_id'])) $inputs['customer_id'] = $license['customer_id'];
// if (empty($inputs['license_number'])) $inputs['license_number'] = $license['license_number'];
// 
// at this point we have identified the license and filled in any missing information
// in the request
$sql = "INSERT INTO product_event_logs "
     . "(ip_address, content)"
     . " VALUES ("
     . "'" . $inputs['ip_address'] . "',"
     . "'" . $inputs['content'] . "')";

$link->query($sql);
echo("SUCCESS");
exit();
?>


